unit InterfaceForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, TRamugenClass, StdCtrls, ExtCtrls, Spin, Menus;

type
  TRamInterface = class(TForm)
    FormContainer: TPanel; ApplicationHeader: TPanel; FooterPanel: TPanel; Image1: TImage;

    //main controls
    ControlPanel: TPanel; PresetButton: TButton; MoodButton: TButton; MindsetButton: TButton;
    PresetSpin: TSpinEdit; MoodSpin: TSpinEdit; MindsetSpin: TSpinEdit;
    //save/load controls
    LoadButton: TButton; SaveButton: TButton; LoadDataButton: TButton; SaveDataButton: TButton;
    //player controls
    PlayButton: TButton; RecordBox: TCheckBox; ReplayButton: TButton; ClearMemoryButton: TButton;

    //non-visual components
    Ramugen1: TRamugen;
    MainMenu1: TMainMenu; File1: TMenuItem; Load1: TMenuItem; Save1: TMenuItem; Exit1: TMenuItem;
    Equipment1: TMenuItem; MidiDevice1: TMenuItem; MidiChannel1: TMenuItem; MidiVoice1: TMenuItem;
    Help1: TMenuItem; Contents1: TMenuItem; About1: TMenuItem; Source1: TMenuItem;
    OpenDialog1: TOpenDialog; SaveDialog1: TSaveDialog;

    //misc.labels
    Label1: TLabel; Label2: TLabel; Label3: TLabel; Label4: TLabel; Label5: TLabel; Label6:
    TLabel; Label7: TLabel; Label8: TLabel; Label9: TLabel; Label11: TLabel; Label10: TLabel; Label12: TLabel;

    procedure Label4Click(Sender: TObject);
    procedure LoadButtonClick(Sender: TObject);
    procedure SaveButtonClick(Sender: TObject);
    procedure MindsetButtonClick(Sender: TObject);
    procedure MoodButtonClick(Sender: TObject);
    procedure PresetButtonClick(Sender: TObject);
    procedure calcspins(Sender: TObject);
    procedure Image1DblClick(Sender: TObject);
    procedure PresetSpinChange(Sender: TObject);
    procedure PlayButtonClick(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure MidiDevice1Click(Sender: TObject);
    procedure MidiChannel1Click(Sender: TObject);
    procedure MidiVoice1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure Source1Click(Sender: TObject);
    procedure Contents1Click(Sender: TObject);
    procedure RecordBoxClick(Sender: TObject);
    procedure SaveDataButtonClick(Sender: TObject);
    procedure LoadDataButtonClick(Sender: TObject);
    procedure ReplayButtonClick(Sender: TObject);
    procedure ClearMemoryButtonClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  RamInterface: TRamInterface;

implementation

uses PresetEditor, ShellApi;
{$R *.dfm}

procedure TRamInterface.Label4Click(Sender: TObject);
begin
 ShellExecute(Handle, 'open', 'http://homepages.tesco.net/gregskius/ramugen.html',nil,nil, SW_SHOWNORMAL) ;
end;

procedure TRamInterface.LoadButtonClick(Sender: TObject);
begin
 ramugen1.LoadFromFile;
end;

procedure TRamInterface.SaveButtonClick(Sender: TObject);
begin
 ramugen1.SaveToFile;
end;

procedure TRamInterface.MindsetButtonClick(Sender: TObject);
begin
 // This is not yet working at the Ramugen Engine level
 // for now, the user can only use one mindset.
 // This will be corrected in due course but doesn't affect usability one iota.
 // Anyone desperately needing to use multiple Mindsets, for now use RamugenLegacy.

 // Ramugen1.ActiveMindset := MindsetSpin.Value;
  Ramugen1.ActiveMindset := 0;
 // Ramugen1.ActiveMindsetFilled := True;
 // calcspins(Self);
  Ramugen1.SetMindsetWeightings;
end;

procedure TRamInterface.MoodButtonClick(Sender: TObject);
begin
  //Edit Mood
  Ramugen1.ActiveMood := MoodSpin.Value;
  Ramugen1.ActiveMoodFilled := True;
  calcspins(Self);
  Ramugen1.SetMoodWeightings;
end;

procedure TRamInterface.PresetButtonClick(Sender: TObject);
begin
  //Edit Preset
  Ramugen1.ActivePreset := PresetSpin.Value;
  Ramugen1.ActivePresetFilled := True;
  calcspins(Self);
  RamPresetEd.Show;
end;

procedure TRamInterface.calcspins(Sender: TObject);
begin
  PresetSpin.MaxValue := Ramugen1.PresetCount;
  PresetSpin.Enabled := (PresetSpin.MaxValue > 0);
  MoodButton.Enabled := (PresetSpin.MaxValue > 1);
  MoodSpin.MaxValue := Ramugen1.MoodCount;
  MoodSpin.Enabled := (MoodSpin.MaxValue > 0);
  MindsetButton.Enabled := (MoodSpin.MaxValue > 1);
  MindsetSpin.MaxValue := Ramugen1.MindsetCount;
  MindsetSpin.Enabled := (MindsetSpin.MaxValue > 0);
end;

procedure TRamInterface.Image1DblClick(Sender: TObject);
var x : Integer;
begin
  //easter egg : apply random parameters!
  Ramugen1.Mu;
  Ramugen1.CurrentPitch := Ramugen1.Pitch.Choose;
   Ramugen1.CurrentPitch2 := Ramugen1.Pitch.Choose;
   Ramugen1.CurrentPitch3 := Ramugen1.Pitch.Choose;
   Ramugen1.CurrentPitch4 := Ramugen1.Pitch.Choose;
   Ramugen1.CurrentPitch5 := Ramugen1.Pitch.Choose;
   Ramugen1.CurrentPitch6 := Ramugen1.Pitch.Choose;
  for x := 0 to 127 do begin
      Ramugen1.ActivePreset := x;
      Ramugen1.ActivePresetFilled := true;
      Ramugen1.Rest.Probability := random;
      if ramugen1.rest.probability > 0.5 then ramugen1.rest.Probability := 0.5;
      Ramugen1.BackTrack.Probability := random;
      if ramugen1.BackTrack.probability > 0.5 then ramugen1.BackTrack.Probability := 0.5;
      Ramugen1.Pitch.Change.Probability := random;
      Ramugen1.Pitch.MoveUp := trunc(random(20));
      Ramugen1.Pitch.MoveDown := trunc(random(20));
      Ramugen1.Duration.Change.Probability := 0.8;
      Ramugen1.Duration.MoveUp := trunc(random(20));
      Ramugen1.Duration.MoveDown := trunc(random(20));

      Ramugen1.Amplitude.Change.Probability := 0.7;
      Ramugen1.TransposeFactor.Change.Probability := random;
      Ramugen1.MoveInterval.Change.Probability := random;

      Ramugen1.ActiveMood := x;
      Ramugen1.PresetChange.Probability := random;
      Ramugen1.ActiveMoodFilled := true;
      Ramugen1.ActiveMindset := 0;
//    Ramugen1.ActiveMindset := x;
//    Ramugen1.ActiveMindsetFilled := true;
                       end;

  Image1.Left := trunc(random(15)) - 5;
  Image1.Top := trunc(random(30)) - 18;

end;

procedure TRamInterface.PresetSpinChange(Sender: TObject);
begin
 Ramugen1.ActivePreset := PresetSpin.Value;
 PresetSpin.Hint := Ramugen1.PresetName;
end;

procedure TRamInterface.PlayButtonClick(Sender: TObject);
begin
  with Ramugen1 do begin
    if PresetCount > 1 then Devolvees := Devolvees + [dvPresets];
    if MoodCount > 1 then Devolvees := Devolvees + [dvMoods];
//  if MindsetCount > 1 then Devolvees := Devolvees + [dvMindsets];
    Playing := not Playing;
    if Playing then PlayButton.Caption := 'Stop'
               else PlayButton.Caption := 'Play';
                   end;
end;

procedure TRamInterface.Exit1Click(Sender: TObject);
begin
exit;
end;

procedure TRamInterface.MidiDevice1Click(Sender: TObject);
var t: string;
x,y : Integer;
begin
 t := inputbox('MIDI Device Selection','Please select a MIDI Device : default is Microsoft MIDI-Mapper','-1');
 val(t,x,y);
 if y <> 0 then x := -1;
 Ramugen1.MIDIDevice := x;
end;

procedure TRamInterface.MidiChannel1Click(Sender: TObject);
var t: string;
x,y : Integer;
begin
 t := inputbox('MIDI Channel Selection','Please select a MIDI Channel (0 to 15)','0');
 val(t,x,y);
 if y <> 0 then x := 0;
 Ramugen1.MIDIChannel := x;
end;


procedure TRamInterface.MidiVoice1Click(Sender: TObject);
var t: string;
x,y : Integer;
begin
 t := inputbox('MIDI Voice Selection','Please select a MIDI Voice (0 to 127)','0');
 val(t,x,y);
 if y <> 0 then x := 0;
 Ramugen1.MIDIVoice := x;
end;

procedure TRamInterface.About1Click(Sender: TObject);
begin
 showmessage('Ramugen public release, open source 15th of July 2007, written by Greg Fox');
end;

procedure TRamInterface.Source1Click(Sender: TObject);
begin
 //not implemented yet
end;

procedure TRamInterface.Contents1Click(Sender: TObject);
begin
  Application.HelpFile := 'ramugen.hlp';
  Application.HelpCommand(HELP_FINDER, 0);
end;

procedure TRamInterface.RecordBoxClick(Sender: TObject);
begin
  ReplayButton.visible := true;
  Ramugen1.StorePlayback := RecordBox.Checked;
end;

procedure TRamInterface.SaveDataButtonClick(Sender: TObject);
begin
  Ramugen1.Memory.SaveToFile;
end;

procedure TRamInterface.LoadDataButtonClick(Sender: TObject);
begin
  Ramugen1.Memory.LoadFromFile;
  ReplayButton.visible := true;
end;

procedure TRamInterface.ReplayButtonClick(Sender: TObject);
begin
  Ramugen1.Memory.PlayPhrase;
end;

procedure TRamInterface.ClearMemoryButtonClick(Sender: TObject);
begin
  ramugen1.memory.clear;
end;

end.
