unit PresetEditor;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, jpeg;

type
  TRamPresetEd = class(TForm)
    FormContainer: TPanel;
    ApplicationHeader: TPanel;    PresName: TEdit;

    //hard limits
    HardLimits: TPanel;
    PitchMin: TEdit; PitchMax: TEdit; PitchWeighted: TCheckBox; PitchWeightings: TButton;
    DurationMax: TEdit; DurationMin: TEdit; DurUS: TEdit;
    AmpMax: TEdit; AmpMin: TEdit; AmpUS: TEdit;
    ArtMax: TEdit; ArtMin: TEdit; ArtUS: TEdit;
    MinNotes: TEdit; MaxNotes: TEdit;
    MoveIntMin: TEdit; MoveIntMax: TEdit; MoveIntWeighted: TCheckBox; MoveIntWeightings: TButton;
    TFMin: TEdit; TFMax: TEdit; TFWeighted: TCheckBox; TFWeightings: TButton;

    //probabilities
    Probabilities: TPanel; ActivateLandmarkP: TEdit; ChangeLandmarkP: TEdit; MoveHandP: TEdit;
    RestP: TEdit; BackTrackP: TEdit; ChangeP: TEdit; ChangeD: TEdit; ChangeA: TEdit; ChordLocalP: TEdit; KeyChangeP: TEdit;

    //buttons
    ButtonPanel: TPanel; CloneButton: TButton; Done: TButton; CancelButton: TButton;

    //misc.labels
    Label1: TLabel; Label2: TLabel; Label3: TLabel; Label4: TLabel; Label6: TLabel;  Label7: TLabel; Label8: TLabel; Label9: TLabel; Label10: TLabel; Label13: TLabel;
    Label14: TLabel; Label12: TLabel; Label15: TLabel; Label16: TLabel; Label11: TLabel; Label17: TLabel; Label20: TLabel; Label18: TLabel; Label19: TLabel; Label21: TLabel;
    Label22: TLabel; Label23: TLabel; Label24: TLabel; Label25: TLabel; Label26: TLabel; Label27: TLabel; Label28: TLabel; Label36: TLabel; Label37: TLabel; Label38: TLabel;
    Label39: TLabel; Label40: TLabel; Label29: TLabel; Label30: TLabel; Label31: TLabel; Label32: TLabel; Label33: TLabel; Label34: TLabel; Label5: TLabel;

    procedure PitchWeightingsClick(Sender: TObject);
    procedure DoneClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure CancelClick(Sender: TObject);
    procedure MelodicIntervalsClick(Sender: TObject);
    procedure TranspositionClick(Sender: TObject);
    procedure CopyFromClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  RamPresetEd: TRamPresetEd;

implementation

uses InterfaceForm;

{$R *.dfm}

procedure TRamPresetEd.PitchWeightingsClick(Sender: TObject);
var p1, p2 : Integer;  //protectors
begin
 PitchWeighted.Checked := true;
 with RamInterface.Ramugen1 do begin
   p1 := pitch.min;
   p2 := pitch.max;
   Pitch.SetRange(PitchMin, PitchMax);
   Pitch.InputWeightings(true);
   Pitch.SetRange(p1 , p2);
 end;
end;

procedure TRamPresetEd.DoneClick(Sender: TObject);
begin
 //Save from form to preset
 with RamInterface.Ramugen1 do begin
   TransposeFactor.SetRange(TFMin, TFMax);
   TransposeFactor.Change.probability := strtofloat(KeyChangeP.text);
   TransposeFactor.Weighted := TFWeighted.Checked;
   ActivateLandmark.Probability := strtofloat(ActivateLandmarkP.text);
   ChangeLandmark.Probability := strtofloat(ChangeLandmarkP.text);
   BackTrack.Probability := strtofloat(BackTrackP.text);
   MoveHand.Probability := strtofloat(MoveHandP.text);
   Rest.Probability := strtofloat(RestP.text);
   ChordLocal.Probability := strtofloat(ChordLocalP.text);
   PresetName := PresName.Text;
   Pitch.SetRange(PitchMin, PitchMax);
   Pitch.Weighted := PitchWeighted.Checked;
   Pitch.Change.Probability := strtofloat(ChangeP.text);
   Duration.SetRange(DurationMin, DurationMax);
   Duration.UnitSize := StrToInt(DurUS.Text);
   Duration.Change.Probability := strtofloat(ChangeD.text);
   Amplitude.SetRange(AmpMin, AmpMax);
   Amplitude.UnitSize := StrToInt(AmpUS.Text);
   Amplitude.Change.Probability := strtofloat(ChangeA.text);
   Articulation.SetRange(ArtMin, ArtMax);
   Articulation.UnitSize := StrToInt(ArtUS.Text);
   NumNotes.SetRange(MinNotes, MaxNotes);
   MoveInterval.SetRange(MoveIntMin, MoveIntMax);
   MoveInterval.Weighted := MoveIntWeighted.Checked;
 end;
Hide;
end;

procedure TRamPresetEd.FormShow(Sender: TObject);
begin
 //Load from preset to form
 with RamInterface.Ramugen1 do begin
   Label2.Caption := 'Preset #' + inttostr(ActivePreset);
   PresName.Text := PresetName;
   TFMin.Text := inttostr(TransposeFactor.Min);
   TFMax.Text := inttostr(TransposeFactor.Max);
   KeyChangeP.Text := floattostr(TransposeFactor.Change.probability);
   TFWeighted.Checked := TransposeFactor.Weighted;
   ActivateLandmarkP.text := floattostr(ActivateLandmark.Probability);
   ChangeLandmarkP.text := floattostr(ChangeLandmark.Probability);
   BackTrackP.text := floattostr(BackTrack.Probability);
   MoveHandP.text := floattostr(MoveHand.Probability);
   RestP.text := floattostr(Rest.Probability);
   ChordLocalP.text := floattostr(ChordLocal.Probability);
   PitchMin.Text := inttostr(Pitch.Min);
   PitchMax.Text := inttostr(Pitch.Max);
   PitchWeighted.Checked := Pitch.Weighted;
   ChangeP.Text := floattostr(Pitch.Change.Probability);
   DurationMin.Text := inttostr(Duration.Min);
   DurationMax.Text := inttostr(Duration.Max);
   DurUS.Text := inttostr(Duration.UnitSize);
   ChangeD.Text := floattostr(Duration.Change.Probability);
   AmpMin.Text := inttostr(Amplitude.Min);
   AmpMax.Text := inttostr(Amplitude.Max);
   AmpUS.Text := inttostr(Amplitude.UnitSize);
   ChangeA.Text := floattostr(Amplitude.Change.Probability);
   ArtMin.Text := inttostr(Articulation.Min);
   ArtMax.Text := inttostr(Articulation.Max);
   ArtUS.Text := inttostr(Articulation.UnitSize);
   MinNotes.Text := inttostr(NumNotes.Min);
   MaxNotes.Text := inttostr(NumNotes.Max);
   MoveIntMin.Text := inttostr(MoveInterval.Min);
   MoveIntMax.Text := inttostr(MoveInterval.Max);
   MoveIntWeighted.Checked := MoveInterval.Weighted;
 end;
end;

procedure TRamPresetEd.CancelClick(Sender: TObject);
begin
 Hide;
end;

procedure TRamPresetEd.MelodicIntervalsClick(Sender: TObject);
var p1, p2 : Integer;  //protectors
begin
 MoveIntWeighted.Checked := true;
 with RamInterface.Ramugen1 do begin
   p1 := MoveInterval.Min;
   p2 := MoveInterval.Max;
   MoveInterval.SetRange(MoveIntMin, MoveIntMax);
   MoveInterval.InputWeightings;
   MoveInterval.SetRange(p1 , p2);
 end;
end;

procedure TRamPresetEd.TranspositionClick(Sender: TObject);
var p1, p2 : Integer;  //protectors
begin
 TFWeighted.Checked := true;
 with RamInterface.Ramugen1 do begin
   p1 := TransposeFactor.Min;
   p2 := TransposeFactor.Max;
   TransposeFactor.SetRange(TFMin, TFMax);
   TransposeFactor.InputWeightings;
   TransposeFactor.SetRange(p1 , p2);
 end;
end;

procedure TRamPresetEd.CopyFromClick(Sender: TObject);
var t,g : Integer; s : string;
begin
  s := inputbox('Copy From Another Preset','Copy from which preset number?','0');
  val(s,t,g); if g <> 0 then exit; 
  RamInterface.Ramugen1.PresetClone(t);
  FormShow(Self);
end;

end.
