unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, TRamugenClass, TSmallRamugenClasses, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    MidiArray1: TMidiArray;
    MidiArray2: TMidiArray;
    MidiArray3: TMidiArray;
    Panel1: TPanel;
    Panel2: TPanel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure MidiArray1NoteStart(Sender: TObject; Pitch,
      CounterValue: Integer; var CarryOnPlaying: Boolean);
    procedure MidiArray2NoteStart(Sender: TObject; Pitch,
      CounterValue: Integer; var CarryOnPlaying: Boolean);
    procedure MidiArray3NoteStart(Sender: TObject; Pitch,
      CounterValue: Integer; var CarryOnPlaying: Boolean);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure MidiArray1PhraseStop(Sender: TObject);
    procedure MidiArray2PhraseStop(Sender: TObject);
    procedure MidiArray3PhraseStop(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
var t : integer;
begin
 randomize;
 midiarray1.OpenMIDIDevice;
 midiarray2.ShareMIDIDeviceOf(midiarray1);
 midiarray3.ShareMIDIDeviceOf(midiarray1);

 midiarray1.Channel := 1;
 midiarray1.Voice := 35;
 midiarray2.Channel := 2;
 midiarray2.voice := 6;
 midiarray3.Channel := 3;
 midiarray3.voice := 53;

 for t := 1 to 13 do
   midiarray1.addnote(trunc(random(40)+25), trunc(random(200))+130, trunc(random(50))+40);

 for t := 1 to 17 do
   midiarray2.addnote(trunc(random(60)+25), trunc(random(200))+280, trunc(random(50))+60);

 for t := 1 to 23 do
   midiarray3.addnote(trunc(random(80)+25), trunc(random(200))+500, trunc(random(50))+77);

end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  alphablendvalue := trunc(random(106))+150;
  midiarray1.PlayPhrase(trunc(random(6))- trunc(random(6)),trunc(random(125))+75);
end;

procedure TForm1.MidiArray1NoteStart(Sender: TObject; Pitch,
  CounterValue: Integer; var CarryOnPlaying: Boolean);
begin
  color := trunc(random(16777215));
  if pitchclass(midiarray2.Pitch(countervalue)) = pitchclass(pitch) then
    begin
      alphablendvalue := trunc(random(106))+150;
      midiarray2.MutatePitch(0.5,2,2);
      midiarray2.MutateDuration(0.5,50,50);
    end;
  if pitchclass(midiarray3.Pitch(countervalue)) = pitchclass(pitch) then
    begin
      alphablendvalue := trunc(random(106))+150;
      midiarray3.MutateAmplitude(0.5,20,20);
      midiarray3.shuffle(0.2,true,true,true,true);
    end;
end;

procedure TForm1.MidiArray2NoteStart(Sender: TObject; Pitch,
  CounterValue: Integer; var CarryOnPlaying: Boolean);
begin
  panel2.color := trunc(random(16777215));
  if pitchclass(midiarray1.Pitch(countervalue)) = pitchclass(pitch) then
    begin
      alphablendvalue := trunc(random(106))+150;
      midiarray1.reverse;
      midiarray1.MutateDuration(0.5,50,50);
      midiarray1.Shuffle(0.5,true,false,false,false);
    end;
  if pitchclass(midiarray3.Pitch(countervalue)) = pitchclass(pitch) then
    begin
      alphablendvalue := trunc(random(106))+150;
      midiarray3.MutateAmplitude(0.5,20,20);
      midiarray3.shuffle(0.2,true,true,true,true);
    end;
end;

procedure TForm1.MidiArray3NoteStart(Sender: TObject; Pitch,
  CounterValue: Integer; var CarryOnPlaying: Boolean);
begin
  panel1.color := trunc(random(16777215));
  if pitchclass(midiarray1.Pitch(countervalue)) = pitchclass(pitch) then
    begin
      alphablendvalue := trunc(random(106))+150;
      midiarray1.reverse;
      midiarray1.MutateDuration(0.5,50,50);
      midiarray1.Shuffle(0.5,true,false,false,false);
    end;
  if pitchclass(midiarray2.Pitch(countervalue)) = pitchclass(pitch) then
    begin
      alphablendvalue := trunc(random(106))+150;
      midiarray2.MutatePitch(0.5,2,2);
      midiarray2.MutateDuration(0.5,50,50);
    end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  alphablendvalue := trunc(random(106))+150;
  midiarray2.PlayPhrase(trunc(random(6))- trunc(random(6)),trunc(random(125))+75);
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  alphablendvalue := trunc(random(106))+150;
  midiarray3.PlayPhrase(trunc(random(6))- trunc(random(6)),trunc(random(125))+75);
end;

procedure TForm1.MidiArray1PhraseStop(Sender: TObject);
begin
  if not midiarray2.PlayingPhrase then midiarray2.PlayPhrase;
  if (not midiarray3.PlayingPhrase) and (random > 0.5) then midiarray3.PlayPhrase;
end;

procedure TForm1.MidiArray2PhraseStop(Sender: TObject);
begin
  if not midiarray3.PlayingPhrase then midiarray3.PlayPhrase;
  if (not midiarray1.PlayingPhrase) and (random > 0.5) then midiarray1.PlayPhrase;
end;

procedure TForm1.MidiArray3PhraseStop(Sender: TObject);
begin
  if not midiarray1.PlayingPhrase then midiarray1.PlayPhrase;
  if (not midiarray2.PlayingPhrase) and (random > 0.5) then midiarray2.PlayPhrase;
end;

end.

